unit UForm;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, StdCtrls, ExtCtrls, UQueue, UStrQueue, UIntQueue, UTask3;

type
  TClassQueue = class of TQueue;

  TMainForm = class(TForm)
    RadioElems: TRadioGroup;
    Solve: TButton;
    Clear: TButton;
    InputField: TLabeledEdit;
    GoodElems: TLabeledEdit;
    BadElems: TLabeledEdit;
    procedure InputFieldExit(Sender: TObject);
    procedure ClearClick(Sender: TObject);
    procedure SolveClick(Sender: TObject);
  private
    { Private declarations }
  public
    { Public declarations }
  end;

var
  MainForm: TMainForm;


implementation

{$R *.dfm}


procedure TMainForm.ClearClick(Sender: TObject);
begin
  InputField.Clear;
  GoodElems.Clear;
  BadElems.Clear;
  InputField.SetFocus;
end;




procedure TMainForm.InputFieldExit(Sender: TObject);
begin
  RadioElems.SetFocus;
end;


procedure TMainForm.SolveClick(Sender: TObject);
var
  q1, q2 : TQueue;
  T : TClassQueue;
  str, temp : string;
  i, len: integer;
  p : pointer;
begin
  //common init
  i:=1;
  str := Trim(InputField.Text);
  len:=length(str);

  //string selected
  if (RadioElems.ItemIndex = 0) then
      //metaclass
    T := TStrQueue
  else
    T := TIntQueue;

  q1 := T.Create;
  q2 := T.Create;

  while (i<=len) do
    begin
      temp:=NextWord(str,i);
      if T.TryStrToElem(temp, p) then
        begin
          if T.CheckElem(p) then
            q1.TryPush(p)
          else
            q2.TryPush(p);
        end;
    end;

  GoodElems.Text := q1.PrintAndClear;
  BadElems.Text := q2.PrintAndClear;
  q1.Destroy;
  q2.Destroy;
  
end;

end.
