unit UQueue;

interface
  Uses
    SysUtils;
  const
    N=100;
  type
    TElem=Pointer;
    TMas=array[0..N-1] of TElem;

  TQueue = class
    private
      FHead, FCount:integer;
      FMas:TMas;
    protected
      function ElemToStr(el : Pointer) : string; virtual; abstract;
      procedure DelElem(el : Pointer); virtual; abstract;
    public
      constructor Create;
      function isEmpty:boolean;
      function TryPush(el:TElem):boolean;
      function TryPop(var el:TElem):boolean;
      function PrintAndClear : string;
      procedure Clear;
      destructor Destroy; override;

      //       
      class function TryStrToElem(word : string; var p : pointer) : boolean; virtual; abstract;
      class function CheckElem(el : pointer) : boolean; virtual; abstract;
  end;

implementation

{ TQueue }
constructor TQueue.Create;
begin
  FHead:=0;
  FCount:=0;
end;



(*
function TQueue.ElemToStr(el: Pointer) : string;
var
  tmp : integer;
begin
  tmp := Integer(el);
  Result := IntToStr(tmp);
end;
*)

function TQueue.isEmpty: boolean;
begin
  Result:=FCount=0;
end;

function TQueue.PrintAndClear : string;
var
  el : TElem;
begin
  Result := '';
  while TryPop(el) do
    begin
      Result := Result + ElemToStr(el);
      Result := Result + ' ';
      DelElem(el);
    end;
end;

(*
procedure TQueue.DelElem(el: Pointer);
begin
  if el <> nil then
    dispose(el);
end;
*)

function TQueue.TryPop(var el: TElem): boolean;
begin
  Result:=FCount<>0;
  if Result then
    begin
      el:=FMas[FHead];
      FHead:=(FHead+1) mod N;
      dec(FCount);
    end;
end;

function TQueue.TryPush(el: TElem): boolean;
var
  tail:integer;
begin
  Result:=FCount<N;
  if Result then
    begin
      tail:=(FHead+FCount) mod N;
      FMas[tail]:=el;
      inc(FCount);
    end;
end;

procedure TQueue.Clear;
var
  el:TElem;
begin
  while TryPop(el) do
    DelElem(el);
end;

destructor TQueue.Destroy;
begin
  Clear;
  inherited Destroy;
end;



end.
